* 8-9-08
* version 6.0




*****************************************************************************************************************************
* Notes (interactive shock):
* the interaction must be a numeric value...not mean or p25.  In the scen commands, if the interactive shock option is specified, the interaction
* needs to have the same value as the modifying (not the shock) variable.  
* if you do this technique, then the modifying variable (non-shock) and the interaction variable (modifying*shock) must have the same value attached...then
* I would multiply that number by the shock macro.
*
* each scenario must depend on the same estsimp, ie, the same estimated model
*
* each variable that is estimated in the model must be included in each scenario (except for the lagged dv and shock variable).  the interaction variables
* ARE included in the setx commmands.  
*
* make sure that the memory is set to a high amount, considering the size of the data set (in observations) may increase with the forecast command.  if you see an error that is obs must be between __ and __, then you need to make memory more and try it again.
* also, limit the number of sims to 1000...otherwise the numlist to replace each obs in the stackvar command fails.
*****************************************************************************************************************************

capture program drop dynsim
program define dynsim, rclass
syntax [if] [in] , dv(varlist max=1) [ldv(varname) ldv_val(real 0)] time(varname) pv(varname) scen1(string) [scen2(string) scen3(string) scen4(string)] COMmand(string) /*
*/	[estoptions(string) sims(real 1000) n(real 50) shock(varname) shock_data(string) pv_start(real 0) forecast(integer 0) inter(string) *]
preserve
set seed 648
generate _random = uniform()					/* make this into a tempvar?*/
sort _random
if `forecast' ~= 0 {
	local forecast_n_minusone = `forecast' - 1
}
if "`shock'" ~= "" {
	sort `pv' `time'
	merge `pv' `time' using "`shock_data'"
	recode _merge (1=4) (3=5) (2=1)
	sort _merge `pv' `time'
*	capture drop _merge
	list `pv' `time' `shock' in 1/`n'
	}
cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	local num = r(num)
      if `n' <=0  {
         di in r _n "You cannot have less than 1 iteration"
         exit 198
      }
	tempvar touse
	generate `touse' = 0
	replace `touse' = 1 `if' `in'
	tokenize `scen1'
	estsimp `command' `dv' `1' `3' `5' `7' `9' `11' `13' `15' `17' `19' `21' `23' `25' `27' `29' `31' `33' `35' `37' `39' `41' `ldv' `shock' /*
*/	if `touse', `estoptions' sims(`sims')
local i = 1			
while `i' <= `num' {
	if "`shock'" ~= "" {
		if `i' == 1 {
			setx mean
			sort _merge `pv' `time'
			qui sum `shock' in 1
			local shock_val = r(mean)
			if "`inter'" ~= "" {
				ch_inter_value, inter(`inter') shock_val(`shock_val') num(1) scen1(`scen1')
				setx `ldv' `ldv_val' `r(scen1)' `shock' `shock_val'
			}	
			if "`inter'" == "" {	
				setx `ldv' `ldv_val' `scen1' `shock' `shock_val' 
			}
			check_est `command' `i' 1			
			first_simqi `i' 1
			if "`inter'" ~= "" {
				if `forecast' ~= 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') shock(`shock') inter(`inter') forecast(`forecast') sims(`sims')
				}
				if `forecast' == 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') shock(`shock') inter(`inter') sims(`sims')
				}
			}
			if "`inter'" == "" {
				if `forecast' ~= 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') shock(`shock') forecast(`forecast') sims(`sims')
				}
				if `forecast' == 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') shock(`shock')  sims(`sims')
				}
			}
		}
		if `i' == 2 {
			setx mean
			sort _merge `pv' `time'
			qui sum `shock' in 1
			local shock_val = r(mean)
			di `shock_val'
			if "`inter'" ~= "" {
				ch_inter_value, inter(`inter') shock_val(`shock_val') num(2) scen2(`scen2')
				setx `ldv' `ldv_val' `r(scen2)' `shock' `shock_val'
			}	
			if "`inter'" == "" {	
				setx `ldv' `ldv_val' `scen2' `shock' `shock_val' 
			}
			check_est `command' `i' 1
			first_simqi `i' 1
			if "`inter'" ~= "" {
				if `forecast' ~= 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') shock(`shock') inter(`inter') forecast(`forecast') sims(`sims')
				}
				if `forecast' == 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') shock(`shock') inter(`inter') sims(`sims')
				}
			}	
			if "`inter'" == "" {
				if `forecast' ~= 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') shock(`shock') forecast(`forecast') sims(`sims')
				}
				if `forecast' == 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') shock(`shock')  sims(`sims')
				}
			}
		}	
		if `i' == 3 {
			setx mean
			sort _merge `pv' `time'
			qui sum `shock' in 1
			local shock_val = r(mean)
			if "`inter'" ~= "" {
				ch_inter_value, inter(`inter') shock_val(`shock_val') num(3) scen3(`scen3')
				setx `ldv' `ldv_val' `r(scen3)' `shock' `shock_val'
			}	
			if "`inter'" == "" {	
				setx `ldv' `ldv_val' `scen3' `shock' `shock_val' 
			}
			check_est `command' `i' 1
			first_simqi `i' 1
			if "`inter'" ~= "" {
				if `forecast' ~= 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') shock(`shock') inter(`inter') forecast(`forecast') sims(`sims')
				}
				if `forecast' == 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') shock(`shock') inter(`inter') sims(`sims')
				}
			}	
			if "`inter'" == "" {
				if `forecast' ~= 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') shock(`shock') forecast(`forecast') sims(`sims')
				}
				if `forecast' == 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') shock(`shock') sims(`sims')
				}
			}
		}	
		if `i' == 4 {
			setx mean
			sort _merge `pv' `time'
			qui sum `shock' in 1
			local shock_val = r(mean)
			if "`inter'" ~= "" {
				ch_inter_value, inter(`inter') shock_val(`shock_val') num(4) scen4(`scen4')
				setx `ldv' `ldv_val' `r(scen4)' `shock' `shock_val'
			}	
			if "`inter'" == "" {	
				setx `ldv' `ldv_val' `scen4' `shock' `shock_val' 
			}
			check_est `command' `i' 1
			first_simqi `i' 1
			if "`inter'" ~= "" {
				if `forecast' ~= 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') shock(`shock') inter(`inter') forecast(`forecast') sims(`sims')
				}
				if `forecast' == 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') shock(`shock') inter(`inter') sims(`sims')
				}
			}	
			if "`inter'" == "" {
				if `forecast' ~= 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') shock(`shock') forecast(`forecast') sims(`sims')
				}
				if `forecast' == 0 {
					next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') shock(`shock') sims(`sims')
				}
			}
		}	
	}
	if "`shock'" == "" {
		if `i' == 1 {
			setx mean
			setx `ldv' `ldv_val' `scen1'		
			check_est `command' `i' 1			
			first_simqi `i' 1
			if `forecast' ~= 0 {
				next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') forecast(`forecast') sims(`sims')
			}
			if `forecast' == 0 {
				next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') sims(`sims')
			}
		}
		if `i' == 2 {
			setx mean
			setx `ldv' `ldv_val' `scen2' 
			check_est `command' `i' 1
			first_simqi `i' 1
			if `forecast' ~= 0 {
				next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') forecast(`forecast') sims(`sims')
			}
			if `forecast' == 0 {
				next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') sims(`sims')
			}
		}
		if `i' == 3 {
			setx mean
			setx `ldv' `ldv_val' `scen3'
			check_est `command' `i' 1
			first_simqi `i' 1
			if `forecast' ~= 0 {
				next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') forecast(`forecast') sims(`sims')
			}
			if `forecast' == 0 {
				next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3')  sims(`sims')
			}
		}
		if `i' == 4 {
			setx mean
			setx `ldv' `ldv_val' `scen4'
			check_est `command' `i' 1
			first_simqi `i' 1
			if `forecast' ~= 0 {
				next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') forecast(`forecast') sims(`sims')
			}
			if `forecast' == 0 {
				next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') sims(`sims')
			}
		}
	}
	local i = `i' + 1
}

if `num' == 4 {
	dynsim_gr, num(`num') pv(`pv') pv_start(`pv_start') time(`time') t(`n') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') shock(`shock') shock_data("`shock_data'") `options'
}
if `num' == 3 {
	dynsim_gr, num(`num') pv(`pv') pv_start(`pv_start') time(`time') t(`n') scen1(`scen1') scen2(`scen2') scen3(`scen3') shock(`shock') shock_data("`shock_data'") `options'
}
if `num' == 2 {
	dynsim_gr, num(`num') pv(`pv') pv_start(`pv_start') time(`time') t(`n') scen1(`scen1') scen2(`scen2') shock(`shock') shock_data("`shock_data'") `options'
}
if `num' == 1 {
	dynsim_gr, num(`num') pv(`pv') pv_start(`pv_start') time(`time') t(`n') scen1(`scen1') shock(`shock') shock_data("`shock_data'") `options'
}
end



capture program drop dynsim_gr
program define dynsim_gr
syntax, num(real) pv(varname) pv_start(real) time(varname) t(real) scen1(string) [scen2(string) scen3(string) scen4(string) shock(varname) shock_data(string)] [*]
*preserve
keep in 1
keep mn_ev_* p97p5_ev_* p2p5_ev_* `pv' `shock' 
gettoken opt : options, parse("()")
if "`opt'" == "" {
	local gr_options title("Dynamic Simulation") xtitle("Year + t") ytitle("Expected Values") note("Note: Bars depict 95% Confidence Intervals")
}
if "`opt'" ~= "" {
	local gr_options `options'
}
if "`shock'" == "" {
	cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	di " Number from command = " `r(num)'
	if `num' == 1 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_, i(`pv') j(time)
		twoway rcap p2p5_ev_1 p97p5_ev_1 time, `gr_options'
	}
	if `num' == 2 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_ mn_ev_2_ p97p5_ev_2_ p2p5_ev_2_, i(`pv') j(time)
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcap p2p5_ev_2 p97p5_ev_2 time, `gr_options'
	}
	if `num' == 3 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_ mn_ev_2_ p97p5_ev_2_ p2p5_ev_2_ mn_ev_3_ p2p5_ev_3_ p97p5_ev_3_, i(`pv') j(time)
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcapsym p2p5_ev_2 p97p5_ev_2 time, msymbol(x) || rcap p2p5_ev_3 p97p5_ev_3 time, `gr_options'
	}
	if `num' == 4 {
		reshape long mn_ev_1_ p2p5_ev_1_ p97p5_ev_1_ mn_ev_2_ p2p5_ev_2_ p97p5_ev_2_ mn_ev_3_ p2p5_ev_3_ p97p5_ev_3_ mn_ev_4_ p2p5_ev_4_ p97p5_ev_4_, i(`pv') j(time)
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcapsym p2p5_ev_2 p97p5_ev_2 time, msymbol(x) || rcapsym p2p5_ev_3 p97p5_ev_3 time, msymbol(s) /*
		*/	|| rcap p2p5_ev_4 p97p5_ev_4 time, `gr_options'
	}
}
if "`shock'" ~= "" {
	cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `num' == 1 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_, i(`pv') j(time)
		capture drop `shock'
		shock_merge, pv(`pv') pv_start(`pv_start') time(`time') n(`t') shock(`shock') shock_data(`shock_data') 
		di 
		di 
		di "The following values are used for this shock variable: `shock' "
		list time `shock'
		twoway rcap p2p5_ev_1 p97p5_ev_1 time, || line `shock' time, yaxis(2) `gr_options'
	}
	cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `num' == 2 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_ mn_ev_2_ p97p5_ev_2_ p2p5_ev_2_, i(`pv') j(time)
		capture drop `shock'
		shock_merge, pv(`pv') pv_start(`pv_start') time(`time') n(`t') shock(`shock') shock_data(`shock_data') 
		di 
		di 
		di "The following values are used for this shock variable: `shock' "
		list time `shock'
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcap p2p5_ev_2 p97p5_ev_2 time, || line `shock' time, yaxis(2) `gr_options'
	}
	cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `num' == 3 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_ mn_ev_2_ p97p5_ev_2_ p2p5_ev_2_ mn_ev_3_ p2p5_ev_3_ p97p5_ev_3_, i(`pv') j(time)
		capture drop `shock'
		shock_merge, pv(`pv') pv_start(`pv_start') time(`time') n(`t') shock(`shock') shock_data(`shock_data') 
		di 
		di 
		di "The following values are used for this shock variable: `shock' "
		list time `shock'
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcapsym p2p5_ev_2 p97p5_ev_2 time, msymbol(x) || rcap p2p5_ev_3 p97p5_ev_3 time, || line `shock' time, yaxis(2) `gr_options'
	}
	cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `num' == 4 {
		reshape long mn_ev_1_ p2p5_ev_1_ p97p5_ev_1_ mn_ev_2_ p2p5_ev_2_ p97p5_ev_2_ mn_ev_3_ p2p5_ev_3_ p97p5_ev_3_ mn_ev_4_ p2p5_ev_4_ p97p5_ev_4_, i(`pv') j(time)
		capture drop `shock'
		shock_merge, pv(`pv') pv_start(`pv_start') time(`time') n(`t') shock(`shock') shock_data(`shock_data') 
		di 
		di 
		di "The following values are used for this shock variable: `shock' "
		list time `shock'
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcapsym p2p5_ev_2 p97p5_ev_2 time, msymbol(x) || rcapsym p2p5_ev_3 p97p5_ev_3 time, msymbol(s) /*
	*/	|| rcap p2p5_ev_4 p97p5_ev_4 time, || line `shock' time, yaxis(2) `gr_options'
	}
}
end

capture program drop first_simqi
program define first_simqi, rclass
args scen_num num
egen mn_ev_`scen_num'_`num' = mean(ev_`scen_num'_`num')
egen p97p5_ev_`scen_num'_`num' = pctile(ev_`scen_num'_`num'), p(97.5)
egen p2p5_ev_`scen_num'_`num' = pctile(ev_`scen_num'_`num'), p(2.5)
qui sum ev_`scen_num'_`num'
local mean = r(mean)
gen ev_`scen_num'_2 = `mean'
return add
return local hh = `mean'
drop ev_`scen_num'_2
end


capture program drop next_simqi
program define next_simqi
syntax,  n(real) hh(real) ldv(string) command(string) num(real) scen1(string) [scen2(string) scen3(string) scen4(string) shock(varname) inter(string) forecast(integer 0) sims(real 1000)]  
local t = `n' + 1
if "`shock'" == "" {
	if `num' == 1 {
		forvalues i = 2(1)`t' {						// for each of the values from 1 to `t' by 1, run these commands
			setx mean
			if `forecast' != 0 {								
				forvalues _forecast_n = 1(1)`forecast' { 
					local i_minus_one = `i'-1
					sort _random
					if `i' == 2 {	
						local _insample = ev_`num'_1 in `_forecast_n'
					}
					if `i' > 2 {
						local _insample = ev_`num'_`i_minus_one' in `_forecast_n'
					}
					setx `ldv' `_insample' `scen1'
*					di `_insample'
					check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				}
				stackvar `sims' `forecast' ev_`num'_`i'_
				rename ev_`num'_`i'_1 ev_`num'_`i'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)			
			}	
			if `forecast' == 0 {
				setx `ldv' `hh' `scen1'
				check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
				qui sum ev_`num'_`i'
				local hh = r(mean)
				drop ev_`num'_`i'
			}
			local i = `i' + 1
		}
*	capture set trace on
	}
	if `num' == 2 {
		forvalues i = 2(1)`t' {							
			setx mean
			if `forecast' != 0 {								
				forvalues _forecast_n = 1(1)`forecast' {
					local i_minus_one = `i'-1
					sort _random
					if `i' == 2 {	
						local _insample = ev_`num'_1 in `_forecast_n'
					}
					if `i' > 2 {
						local _insample = ev_`num'_`i_minus_one' in `_forecast_n'
					}
					setx `ldv' `_insample' `scen2'
*					di `_insample'
					check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				}
				stackvar `sims' `forecast' ev_`num'_`i'_
				rename ev_`num'_`i'_1 ev_`num'_`i'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)	
			}
			if `forecast' == 0 {
				setx `ldv' `hh' `scen2'
				check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
				qui sum ev_`num'_`i'
				local hh = r(mean)
				drop ev_`num'_`i'
			}
			local i = `i' + 1
		}
	}
	if `num' == 3 {
		forvalues i = 2(1)`t' {							
			setx mean
			if `forecast' != 0 {								
				forvalues _forecast_n = 1(1)`forecast' { 
					local i_minus_one = `i'-1
					sort _random
					if `i' == 2 {	
						local _insample = ev_`num'_1 in `_forecast_n'
					}
					if `i' > 2 {
						local _insample = ev_`num'_`i_minus_one' in `_forecast_n'
					}
					setx `ldv' `_insample' `scen3'
*					di `_insample'
					check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				}
				stackvar `sims' `forecast' ev_`num'_`i'_
				rename ev_`num'_`i'_1 ev_`num'_`i'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)	
			}
			if `forecast' == 0 {
				setx `ldv' `hh' `scen3'
				check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
				qui sum ev_`num'_`i'
				local hh = r(mean)
				drop ev_`num'_`i'
			}
			local i = `i' + 1
		}
	}
	if `num' == 4 {
		forvalues i = 2(1)`t' {							
			setx mean
			if `forecast' != 0 {								
				forvalues _forecast_n = 1(1)`forecast' {
					local i_minus_one = `i'-1
					sort _random
					if `i' == 2 {	
						local _insample = ev_`num'_1 in `_forecast_n'
					}
					if `i' > 2 {
						local _insample = ev_`num'_`i_minus_one' in `_forecast_n'
					}
					setx `ldv' `_insample' `scen4'
*					di `_insample' 
					check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				}
				stackvar `sims' `forecast' ev_`num'_`i'_
				rename ev_`num'_`i'_1 ev_`num'_`i'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)	
			}
			if `forecast' == 0 {
				setx `ldv' `hh' `scen4'
				check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
				qui sum ev_`num'_`i'
				local hh = r(mean)
				drop ev_`num'_`i'
			}
			local i = `i' + 1
		}
	}
}
if "`shock'" ~= "" {
	if `num' == 1 {
		forvalues i = 2(1)`t' {
			setx mean
			sort _merge `pv' `time' 
			qui sum `shock' in `i'
			local shock_val = `r(mean)'
			if `forecast' != 0 {								
				forvalues _forecast_n = 1(1)`forecast' { 
					local i_minus_one = `i'-1
					sort _random
					if `i' == 2 {	
						sort ev_`num'_1
						qui sum ev_`num'_1 in `_forecast_n'
						local _insample = `r(mean)'
					}
					if `i' > 2 {
						sort ev_`num'_`i_minus_one'
						qui sum ev_`num'_`i_minus_one' in `_forecast_n'
						local _insample = `r(mean)'
					}
					if "`inter'" ~= "" {
						ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen1(`scen1')
						setx `ldv' `_insample' `r(scen1)' `shock' `shock_val'
					}
					if "`inter'" == "" {
						setx `ldv' `_insample' `scen1' `shock' `shock_val'
					}	
					setx `ldv' `_insample' `scen1'
*					di `_insample'
					check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				}
				stackvar `sims' `forecast' ev_`num'_`i'_
				rename ev_`num'_`i'_1 ev_`num'_`i'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)			
			}
			if `forecast' == 0 {
				if "`inter'" ~= "" {
					ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen1(`scen1')
					setx `ldv' `hh' `r(scen1)' `shock' `shock_val'
				}
				if "`inter'" == "" {
					setx `ldv' `hh' `scen1' `shock' `shock_val'
				}	
				check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
				qui sum ev_`num'_`i'
				local hh = r(mean)
				drop ev_`num'_`i'
			}
		local i = `i' + 1
		}
	}
	if `num' == 2 {
		forvalues i = 2(1)`t' {							
			setx mean
			sort _merge `pv' `time' 
			qui sum `shock' in `i'
			local shock_val = r(mean)
			if `forecast' != 0 {								
				forvalues _forecast_n = 1(1)`forecast' { 
					local i_minus_one = `i'-1
					sort _random
					if `i' == 2 {	
						sort ev_`num'_1
						qui sum ev_`num'_1 in `_forecast_n'
						local _insample = `r(mean)'
					}
					if `i' > 2 {
						sort ev_`num'_`i_minus_one'
						qui sum ev_`num'_`i_minus_one' in `_forecast_n'
						local _insample = `r(mean)'
					}
					if "`inter'" ~= "" {
						ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen2(`scen2')
						setx `ldv' `_insample' `r(scen2)' `shock' `shock_val'
					}
					if "`inter'" == "" {
						setx `ldv' `_insample' `scen2' `shock' `shock_val'
					}	
					setx `ldv' `_insample' `scen2'
*					di `_insample'
					check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				}
				stackvar `sims' `forecast' ev_`num'_`i'_
				rename ev_`num'_`i'_1 ev_`num'_`i'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)			
			}
			if `forecast' == 0 {
				if "`inter'" ~= "" {
					ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen2(`scen2')
					setx `ldv' `hh' `r(scen2)' `shock' `shock_val'
				}
				if "`inter'" == "" {
					setx `ldv' `hh' `scen2' `shock' `shock_val'
				}	
				check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
				qui sum ev_`num'_`i'
				local hh = r(mean)
				drop ev_`num'_`i'
			}
		local i = `i' + 1		
		}
	}
	if `num' == 3 {
		forvalues i = 2(1)`t' {							
			setx mean
			sort _merge `pv' `time' 
			qui sum `shock' in `i'
			local shock_val = r(mean)
			if `forecast' != 0 {								
				forvalues _forecast_n = 1(1)`forecast' { 
					local i_minus_one = `i'-1
					sort _random
					if `i' == 2 {	
						sort ev_`num'_1
						qui sum ev_`num'_1 in `_forecast_n'
						local _insample = `r(mean)'
					}
					if `i' > 2 {
						sort ev_`num'_`i_minus_one'
						qui sum ev_`num'_`i_minus_one' in `_forecast_n'
						local _insample = `r(mean)'
					}
					if "`inter'" ~= "" {
						ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen3(`scen3')
						setx `ldv' `_insample' `r(scen3)' `shock' `shock_val'
					}
					if "`inter'" == "" {
						setx `ldv' `_insample' `scen3' `shock' `shock_val'
					}	
					setx `ldv' `_insample' `scen3'
*					di `_insample'
					check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				}
				stackvar `sims' `forecast' ev_`num'_`i'_
				rename ev_`num'_`i'_1 ev_`num'_`i'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)			
			}
			if `forecast' == 0 {
				if "`inter'" ~= "" {
					ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen3(`scen3')
					setx `ldv' `hh' `r(scen3)' `shock' `shock_val'
				}
				if "`inter'" == "" {
					setx `ldv' `hh' `scen3' `shock' `shock_val'
				}	
				check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
				qui sum ev_`num'_`i'
				local hh = r(mean)
				drop ev_`num'_`i'
			}
		local i = `i' + 1
		}
	}
	if `num' == 4 {
		forvalues i = 2(1)`t' {							
			setx mean
			sort _merge `pv' `time' 
			qui sum `shock' in `i'
			local shock_val = r(mean)
			if `forecast' != 0 {								
				forvalues _forecast_n = 1(1)`forecast' { 
					local i_minus_one = `i'-1
					sort _random
					if `i' == 2 {	
						sort ev_`num'_1
						qui sum ev_`num'_1 in `_forecast_n'
						local _insample = `r(mean)'
					}
					if `i' > 2 {
						sort ev_`num'_`i_minus_one'
						qui sum ev_`num'_`i_minus_one' in `_forecast_n'
						local _insample = `r(mean)'
					}
					if "`inter'" ~= "" {
						ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen4(`scen4')
						setx `ldv' `_insample' `r(scen4)' `shock' `shock_val'
					}
					if "`inter'" == "" {
						setx `ldv' `_insample' `scen4' `shock' `shock_val'
					}	
					setx `ldv' `_insample' `scen4'
*					di `_insample'
					check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				}
				stackvar `sims' `forecast' ev_`num'_`i'_
				rename ev_`num'_`i'_1 ev_`num'_`i'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)			
			}
			if `forecast' == 0 {
				if "`inter'" ~= "" {
					ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen4(`scen4')
					setx `ldv' `hh' `r(scen4)' `shock' `shock_val'
				}
				if "`inter'" == "" {
					setx `ldv' `hh' `scen4' `shock' `shock_val'
				}	
				check_est_2 `command' `i' `num' `forecast' `_forecast_n'
				egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
				egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
				egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
				qui sum ev_`num'_`i'
				local hh = r(mean)
				drop ev_`num'_`i'
			}
		local i = `i' + 1
		}
	}
}													
end



capture program drop check_est
program define check_est
args command scen_num i
	if "`command'" == "regress" {
		local command regress
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "logit" {
		local command logit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "probit" {
		local command probit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "ologit" {
		local command ologit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "oprobit" {
		local command oprobit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "mlogit" {
		local command mlogit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "poisson" {
		local command poisson
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "nbreg" {
		local command nbreg
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "weibull" {
		local command weibull
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
	}
	if `"`command'"' == "sureg" {
		local command sureg
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
	}
end

capture program drop check_est_2
program define check_est_2
args command i scen_num forecast _forecast_n
	if "`command'" == "regress" {
		local command regress
		if `4' ~= . {
			qui simqi, genev(ev_`scen_num'_`i'_`_forecast_n')
			qui simqi, listx
			local _forecast_n = `_forecast_n' + 1
		}
		if `4' == . {
			qui simqi, genev(ev_`scen_num'_`i')
			qui simqi, listx
		}
	}
	if `"`command'"' == "logit" {
		local command logit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
	}
	if `"`command'"' == "probit" {
		local command probit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
	}
	if `"`command'"' == "ologit" {
		local command ologit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
	}
	if `"`command'"' == "oprobit" {
		local command oprobit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
	}
	if `"`command'"' == "mlogit" {
		local command mlogit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
	}
	if `"`command'"' == "poisson" {
		local command poisson
		simqi, genev(ev_`num')
		simqi, listx
	}
	if `"`command'"' == "nbreg" {
		local command nbreg
		simqi, genev(ev_`num')
		simqi, listx
	}
	if `"`command'"' == "weibull" {
		local command weibull
		simqi, genev(ev_`num')
		simqi, listx
	}
	if `"`command'"' == "sureg" {
		local command sureg
		simqi, genev(ev_`num')
		simqi, listx
	}
end

capture program drop stackvar
program define stackvar
args no_sim no_var stem
*capture set trace off
quietly {
	local start = `no_sim' + 1			/* this should be the end of the b simulations...not the end of the data set.*/
	local end = `start' + (`no_sim'-1)
	local total_var = `no_var' + 1
	local total_obs = `start' + (`no_sim'*`no_var') - 1
	set obs `total_obs'
	local a = 1
	foreach it of numlist 2(1)`no_var' {
		foreach num of numlist `start'(1)`end' {
			quietly sum `stem'`it' in `a'
			local value = r(mean)
			quietly replace `stem'1 = `value' in `num'
			local a = `a' + 1
			if `a' > `no_sim' {
				local it = `it' + 1
				local a = 1
			}
		}
		local start = `start'+`no_sim'
		local end = `start'+(`no_sim'-1)
	}
	drop `stem'2-`stem'`no_var'
}
end


capture program drop shock_merge
program define shock_merge
syntax, pv(varname) pv_start(real) time(string) n(real) shock(string) shock_data(string)
capture drop `shock' `time'
local stop = `pv_start' + `n' 
egen `time' = fill(`pv_start'(1)`stop')
sort `time'
merge `time' using "`shock_data'", keep(`shock') sort
drop if _merge !=3
end

capture program drop ch_inter_value
program define ch_inter_value, rclass
syntax, inter(string) shock_val(real) num(real) [ scen1(string) scen2(string) scen3(string) scen4(string)]
		tokenize "`inter'"
		local inter1 `1'
		local inter2 `2'
		local inter3 `3'
		local inter4 `4'
		if "`inter4'" ~= "" {
			local stop = 4
		}
		if "`inter4'" == "" & "`inter3'" ~= "" {
			local stop = 3
		}
		if "`inter4'" == "" & "`inter3'" == "" & "`inter2'" ~= "" {
			local stop = 2
		}
		if "`inter4'" == "" & "`inter3'" == "" & "`inter2'" == "" {
			local stop = 1
		}
			forvalues x = 1(1)`stop' {
				if `num' == 1 {
					tokenize `scen1'
				}
				if `num' == 2 {
					tokenize `scen2'
				}
				if `num' == 3 {
					tokenize `scen3'
				}
				if `num' == 4 {
					tokenize `scen4'
				}
					forvalues i = 1(2)41 {
					 	if "``i''" == "`inter`x''" {
					 		local next = `i' + 1
							local value = ``next''*`shock_val'
							local `next' = `value'
 						}
 					}
				local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
				return local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			}
end


capture program drop cr_scen_miss
program define cr_scen_miss, rclass
syntax, scen1(string) [ scen2(string) scen3(string) scen4(string) ]
tokenize "`scen1'"
local scen_miss_1 `1'
tokenize "`scen2'"
local scen_miss_2 `1'
tokenize "`scen3'"
local scen_miss_3 `1'
tokenize "`scen4'"
local scen_miss_4 `1'
if "`scen_miss_2'" == "" & "`scen_miss_3'" == "" & "`scen_miss_4'" == "" {
	local num = 1
}
if "`scen_miss_4'" == "" & "`scen_miss_3'" == "" & "`scen_miss_2'" ~= "" {
	local num = 2
}
if "`scen_miss_4'" == "" & "`scen_miss_3'" ~= "" {
	local num = 3
}
if "`scen4'" ~= "" {
	local num = 4
}
return local num `num'
end



