* 05/01/07
* It is dynsim v 4.0, is able to incorporate interactive shocks.  Or, models where the shock is a part of an interaction.
* This dynsim command is specifically designed to handle panel-corrected standard errors (PCSE) 

capture program drop dynsim_pcse
program define dynsim_pcse, rclass
syntax [if] [in] , dv(varlist max=1) [ldv(varname) ldv_val(real 0)] time(varname) pv(varname) scen1(string) [scen2(string) scen3(string) scen4(string)] COMmand(string) /*
*/	[estoptions(string) sims(real 1000) n(real 50) shock(varname) shock_data(string) pv_start(real 0) inter(string) *]
preserve
if "`shock'" ~= "" {
	sort `pv' `time'
	merge `pv' `time' using "`shock_data'" 
	recode _merge (1=4) (3=5) (2=1)
	sort _merge `pv' `time'
	capture drop _merge
	list `pv' `time' `shock' in 1/`n'
	}
cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	local num = r(num)
      if `n' <=0  {
         di in r _n "You cannot have less than 1 iteration"
         exit 198
      }
	tempvar touse
	generate `touse' = 0
	replace `touse' = 1 `if' `in'
	tokenize `scen1'
	estsimp_pcse `command' `dv' `1' `3' `5' `7' `9' `11' `13' `15' `17' `19' `21' `23' `25' `27' `29' `31' `33' `35' `37' `39' `41' `ldv' `shock' /*
*/	if `touse', `estoptions' sims(`sims')

local i = 1			
while `i' <= `num' {
* the initial setx
if "`shock'" ~= "" {
	if `i' == 1 {
	setx mean
	sum `shock' in 1
	local shock_val = r(mean)
	* di `shock_val'

********************************************************************************************************************************************
	* syntax, inter(string) shock_val(real) num(real) [ scen1(string) scen2(string) scen3(string) scen4(string)]
	* this is where I need to tokenize the scen and interact the shock variable with the value of the interacted variable (which is set to the 
	* modifying variable's value).  maybe use the ch_inter_value command.  
********************************************************************************************************************************************
		if "`inter'" ~= "" {
			ch_inter_value, inter(`inter') shock_val(`shock_val') num(1) scen1(`scen1')
			setx `ldv' `ldv_val' `r(scen1)' `shock' `shock_val'
		}	
		if "`inter'" == "" {	
			setx `ldv' `ldv_val' `scen1' `shock' `shock_val' 
		}
		check_est `command' `i' 1			
		first_simqi `i' 1
			* return list
		if "`inter'" ~= "" {
			next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') shock(`shock') inter(`inter')
		}
		if "`inter'" == "" {
			next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') shock(`shock') 
		}
	}
	if `i' == 2 {
	setx mean
	sum `shock' in 1
	local shock_val = r(mean)
	* di `shock_val'
		if "`inter'" ~= "" {
			ch_inter_value, inter(`inter') shock_val(`shock_val') num(2) scen2(`scen2')
			setx `ldv' `ldv_val' `r(scen2)' `shock' `shock_val'
		}	
		if "`inter'" == "" {	
			setx `ldv' `ldv_val' `scen2' `shock' `shock_val' 
		}
		check_est `command' `i' 1
		first_simqi `i' 1
		if "`inter'" ~= "" {
			next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') shock(`shock') inter(`inter')
		}
		if "`inter'" == "" {
			next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') shock(`shock') 
		}	
	}
	if `i' == 3 {
	setx mean
	sum `shock' in 1
	local shock_val = r(mean)
	* di `shock_val'
		if "`inter'" ~= "" {
			ch_inter_value, inter(`inter') shock_val(`shock_val') num(3) scen3(`scen3')
			setx `ldv' `ldv_val' `r(scen3)' `shock' `shock_val'
		}	
		if "`inter'" == "" {	
			setx `ldv' `ldv_val' `scen3' `shock' `shock_val' 
		}
		check_est `command' `i' 1
		first_simqi `i' 1
		if "`inter'" ~= "" {
			next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') shock(`shock') inter(`inter')
		}
		if "`inter'" == "" {
			next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') shock(`shock') 
		}		
	}
	if `i' == 4 {
	setx mean
	sum `shock' in 1
	local shock_val = r(mean)
	* di `shock_val'
		if "`inter'" ~= "" {
			ch_inter_value, inter(`inter') shock_val(`shock_val') num(4) scen4(`scen4')
			setx `ldv' `ldv_val' `r(scen4)' `shock' `shock_val'
		}	
		if "`inter'" == "" {	
			setx `ldv' `ldv_val' `scen4' `shock' `shock_val' 
		}
		check_est `command' `i' 1
		first_simqi `i' 1
		if "`inter'" ~= "" {
			next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') shock(`shock') inter(`inter')
		}
		if "`inter'" == "" {
			next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') shock(`shock') 
		}		
	}
}
if "`shock'" == "" {
	if `i' == 1 {
	setx mean
	setx `ldv' `ldv_val' `scen1'		
		check_est `command' `i' 1			
		first_simqi `i' 1
		*	return list
		next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1')
	}
	if `i' == 2 {
	setx mean
	setx `ldv' `ldv_val' `scen2' 
		check_est `command' `i' 1
		first_simqi `i' 1
		next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2')
	}
	if `i' == 3 {
	setx mean
	setx `ldv' `ldv_val' `scen3'
		check_est `command' `i' 1
		first_simqi `i' 1
		next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3')
	}
	if `i' == 4 {
	setx mean
	setx `ldv' `ldv_val' `scen4'
		check_est `command' `i' 1
		first_simqi `i' 1
		next_simqi, n(`n') hh(`r(hh)') ldv(`ldv') command(`command') num(`i') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	}
}
local i = `i' + 1
}
if `num' == 4 {
	dynsim_gr, num(`num') pv(`pv') pv_start(`pv_start') time(`time') t(`n') scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4') shock(`shock') shock_data("`shock_data'") `options'
}
if `num' == 3 {
	dynsim_gr, num(`num') pv(`pv') pv_start(`pv_start') time(`time') t(`n') scen1(`scen1') scen2(`scen2') scen3(`scen3') shock(`shock') shock_data("`shock_data'") `options'
}
if `num' == 2 {
	dynsim_gr, num(`num') pv(`pv') pv_start(`pv_start') time(`time') t(`n') scen1(`scen1') scen2(`scen2') shock(`shock') shock_data("`shock_data'") `options'
}
if `num' == 1 {
	dynsim_gr, num(`num') pv(`pv') pv_start(`pv_start') time(`time') t(`n') scen1(`scen1') shock(`shock') shock_data("`shock_data'") `options'
}
capture drop b* mn_* p2p5_* p97p5_* ev_*
end



capture program drop dynsim_gr
program define dynsim_gr
syntax, num(real) pv(varname) pv_start(real) time(varname) t(real) scen1(string) [scen2(string) scen3(string) scen4(string) shock(varname) shock_data(string)] [*]
	preserve
	keep in 1
	keep mn_ev_* p97p5_ev_* p2p5_ev_* `pv' `shock' 
	gettoken opt : options, parse("()")
		if "`opt'" == "" {
			local gr_options title("Dynamic Simulation") xtitle("Year + t") ytitle("Expected Values") /*
*/			note("Note: Bars depict 95% Confidence Intervals")
		}
		if "`opt'" ~= "" {
			local gr_options `options'
		}
if "`shock'" == "" {
cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `r(num)' == 1 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_, i(`pv') j(time)
		twoway rcap p2p5_ev_1 p97p5_ev_1 time, `gr_options'
	}
	if `r(num)' == 2 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_ mn_ev_2_ p97p5_ev_2_ p2p5_ev_2_, i(`pv') j(time)
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcap p2p5_ev_2 p97p5_ev_2 time, `gr_options'
	}
	if `r(num)' == 3 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_ mn_ev_2_ p97p5_ev_2_ p2p5_ev_2_ mn_ev_3_ p2p5_ev_3_ p97p5_ev_3_, i(`pv') j(time)
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcapsym p2p5_ev_2 p97p5_ev_2 time, msymbol(x) || rcap p2p5_ev_3 p97p5_ev_3 time, `gr_options'
	}
	if `r(num)' == 4 {
		reshape long mn_ev_1_ p2p5_ev_1_ p97p5_ev_1_ mn_ev_2_ p2p5_ev_2_ p97p5_ev_2_ mn_ev_3_ p2p5_ev_3_ p97p5_ev_3_ mn_ev_4_ p2p5_ev_4_ p97p5_ev_4_, i(`pv') j(time)
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcapsym p2p5_ev_2 p97p5_ev_2 time, msymbol(x) || rcapsym p2p5_ev_3 p97p5_ev_3 time, msymbol(s) /*
	*/	|| rcap p2p5_ev_4 p97p5_ev_4 time, `gr_options'
	}
}
if "`shock'" ~= "" {
cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `r(num)' == 1 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_, i(`pv') j(time)
		capture drop `shock'
		shock_merge, pv(`pv') pv_start(`pv_start') time(`time') n(`t') shock(`shock') shock_data(`shock_data') 
		di 
		di 
		di "The following values are used for this shock variable: `shock' "
		list time `shock'
		twoway rcap p2p5_ev_1 p97p5_ev_1 time, || line `shock' time, yaxis(2) `gr_options'
	}
cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `r(num)' == 2 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_ mn_ev_2_ p97p5_ev_2_ p2p5_ev_2_, i(`pv') j(time)
		capture drop `shock'
		shock_merge, pv(`pv') pv_start(`pv_start') time(`time') n(`t') shock(`shock') shock_data(`shock_data') 
		di 
		di 
		di "The following values are used for this shock variable: `shock' "
		list time `shock'
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcap p2p5_ev_2 p97p5_ev_2 time, || line `shock' time, yaxis(2) `gr_options'
*		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcap p2p5_ev_2 p97p5_ev_2 time, `gr_options'
	}
cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `r(num)' == 3 {
		reshape long mn_ev_1_ p97p5_ev_1_ p2p5_ev_1_ mn_ev_2_ p97p5_ev_2_ p2p5_ev_2_ mn_ev_3_ p2p5_ev_3_ p97p5_ev_3_, i(`pv') j(time)
		capture drop `shock'
		shock_merge, pv(`pv') pv_start(`pv_start') time(`time') n(`t') shock(`shock') shock_data(`shock_data') 
		di 
		di 
		di "The following values are used for this shock variable: `shock' "
		list time `shock'
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcapsym p2p5_ev_2 p97p5_ev_2 time, msymbol(x) || rcap p2p5_ev_3 p97p5_ev_3 time, || line `shock' time, yaxis(2) `gr_options'
	}
cr_scen_miss, scen1(`scen1') scen2(`scen2') scen3(`scen3') scen4(`scen4')
	if `r(num)' == 4 {
		reshape long mn_ev_1_ p2p5_ev_1_ p97p5_ev_1_ mn_ev_2_ p2p5_ev_2_ p97p5_ev_2_ mn_ev_3_ p2p5_ev_3_ p97p5_ev_3_ mn_ev_4_ p2p5_ev_4_ p97p5_ev_4_, i(`pv') j(time)
		capture drop `shock'
		shock_merge, pv(`pv') pv_start(`pv_start') time(`time') n(`t') shock(`shock') shock_data(`shock_data') 
		di 
		di 
		di "The following values are used for this shock variable: `shock' "
		list time `shock'
		twoway rcapsym p2p5_ev_1 p97p5_ev_1 time, msymbol(sh) || rcapsym p2p5_ev_2 p97p5_ev_2 time, msymbol(x) || rcapsym p2p5_ev_3 p97p5_ev_3 time, msymbol(s) /*
	*/	|| rcap p2p5_ev_4 p97p5_ev_4 time, || line `shock' time, yaxis(2) `gr_options'
	}
}
end

capture program drop first_simqi
program define first_simqi, rclass
args scen_num num
	egen mn_ev_`scen_num'_`num' = mean(ev_`scen_num'_`num')
	egen p97p5_ev_`scen_num'_`num' = pctile(ev_`scen_num'_`num'), p(97.5)
	egen p2p5_ev_`scen_num'_`num' = pctile(ev_`scen_num'_`num'), p(2.5)
	sum ev_`scen_num'_`num'
		local mean = r(mean)
	gen ev_`scen_num'_2 = `mean'
	return add
	return local hh = `mean'
	* di `return(hh)'
	drop ev_`scen_num'_2
end


capture program drop next_simqi
program define next_simqi
syntax,  n(real) hh(real) ldv(string) command(string) num(real) scen1(string) [scen2(string) scen3(string) scen4(string) shock(varname) inter(string)]  
			local t = `n' + 1
			forvalues i = 2(1)`t' {						// for each of the values from 1 to `t' by 1, run these commands
						* di "this iteration is " `i'
						* di `hh'
						setx mean
						if "`shock'" == "" {
							if `num' == 1 {
								setx `ldv' `hh' `scen1'
							}
							if `num' == 2 {
								setx `ldv' `hh' `scen2'
							}
							if `num' == 3 {
								setx `ldv' `hh' `scen3'
							}
							if `num' == 4 {
								setx `ldv' `hh' `scen4'
							}
						}
						if "`shock'" ~= "" {
							if `num' == 1 {
								sum `shock' in `i'
								local shock_val = r(mean)
								if "`inter'" ~= "" {
									ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen1(`scen1')
									setx `ldv' `hh' `r(scen1)' `shock' `shock_val'
								}
								if "`inter'" == "" {
									setx `ldv' `hh' `scen1' `shock' `shock_val'
								}
							}
							if `num' == 2 {
								sum `shock' in `i'
								local shock_val = r(mean)
								if "`inter'" ~= "" {
									ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen2(`scen2')
									setx `ldv' `hh' `r(scen2)' `shock' `shock_val'
								}
								if "`inter'" == "" {
									setx `ldv' `hh' `scen2' `shock' `shock_val'
								}							
							}
							if `num' == 3 {
								sum `shock' in `i'
								local shock_val = r(mean)
								if "`inter'" ~= "" {
									ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen3(`scen3')
									setx `ldv' `hh' `r(scen3)' `shock' `shock_val'
								}
								if "`inter'" == "" {
									setx `ldv' `hh' `scen3' `shock' `shock_val'
								}
							}
							if `num' == 4 {
								sum `shock' in `i'
								local shock_val = r(mean)
								if "`inter'" ~= "" {
									ch_inter_value, inter(`inter') shock_val(`shock_val') num(`num') scen4(`scen4')
									setx `ldv' `hh' `r(scen4)' `shock' `shock_val'
								}
								if "`inter'" == "" {
									setx `ldv' `hh' `scen4' `shock' `shock_val'
								}
							}
						}													
						check_est_2 `command' `i' `num'				
						egen mn_ev_`num'_`i' = mean(ev_`num'_`i')
						egen p97p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(97.5)
						egen p2p5_ev_`num'_`i' = pctile(ev_`num'_`i'), p(2.5)
						sum ev_`num'_`i'
						local hh = r(mean)
						* di `hh'
						drop ev_`num'_`i'
			}		
end



capture program drop check_est
program define check_est
args command scen_num i
	if "`command'" == "xtpcse" {
		local command xtpcse
		simqi_pcse, genev(ev_`scen_num'_`i')
		simqi_pcse, listx
		}
	if "`command'" == "regress" {
		local command regress
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "logit" {
		local command logit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "probit" {
		local command probit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "ologit" {
		local command ologit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "oprobit" {
		local command oprobit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "mlogit" {
		local command mlogit
		simqi, prval(1) genpv(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "poisson" {
		local command poisson
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "nbreg" {
		local command nbreg
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "weibull" {
		local command weibull
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "sureg" {
		local command sureg
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
		}
end

capture program drop check_est_2
program define check_est_2
args command i scen_num
	if "`command'" == "xtpcse" {
		local command xtpcse
		simqi_pcse, genev(ev_`scen_num'_`i')
		simqi_pcse, listx
		}
	if "`command'" == "regress" {
		local command regress
		simqi, genev(ev_`scen_num'_`i')
		simqi, listx
		}
	if `"`command'"' == "logit" {
		local command logit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
		}
	if `"`command'"' == "probit" {
		local command probit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
		}
	if `"`command'"' == "ologit" {
		local command ologit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
		}
	if `"`command'"' == "oprobit" {
		local command oprobit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
		}
	if `"`command'"' == "mlogit" {
		local command mlogit
		simqi, prval(1) genpv(pv_`num')
		simqi, listx
		}
	if `"`command'"' == "poisson" {
		local command poisson
		simqi, genev(ev_`num')
		simqi, listx
		}
	if `"`command'"' == "nbreg" {
		local command nbreg
		simqi, genev(ev_`num')
		simqi, listx
		}
	if `"`command'"' == "weibull" {
		local command weibull
		simqi, genev(ev_`num')
		simqi, listx
		}
	if `"`command'"' == "sureg" {
		local command sureg
		simqi, genev(ev_`num')
		simqi, listx
		}
end


capture program drop shock_merge
program define shock_merge
syntax, pv(varname) pv_start(real) time(string) n(real) shock(string) shock_data(string)
	capture drop `shock' `time'
		local stop = `pv_start' + `n' 
	egen `time' = fill(`pv_start'(1)`stop')
	sort `pv' `time'
	merge `pv' `time' using "`shock_data'", keep(`shock')
	drop if _merge !=3
end

/*
capture program drop ch_inter_value
program define ch_inter_value, rclass
syntax, inter(string) shock_val(real) num(real) [ scen1(string) scen2(string) scen3(string) scen4(string)]
		tokenize "`inter'"
		local inter1 `1'
		local inter2 `2'
		local inter3 `3'
		local inter4 `4'
		if "`inter4'" ~= "" {
			forvalues x = 1(1)4 {
				if `num' == 1 {
					tokenize `scen1'
				}
				if `num' == 2 {
					tokenize `scen2'
				}
				if `num' == 3 {
					tokenize `scen3'
				}
				if `num' == 4 {
					tokenize `scen4'
				}
				if "`1'" == "`inter`x''" {
					local 2 = `2'*`shock_val'
				}
				if "`3'" == "`inter`x''" {
					local 4 = `4'*`shock_val'
				}
				if "`5'" == "`inter`x''" {
					local 6 = `6'*`shock_val'
				}
				if "`7'" == "`inter`x''" {
					local 8 = `8'*`shock_val'
				}
				if "`9'" == "`inter`x''" {
					local 10 = `10'*`shock_val'
				}
				if "`11'" == "`inter`x''" {
					local 12 = `12'*`shock_val'
				}
				if "`13'" == "`inter`x''" {
					local 14 = `14'*`shock_val'
				}
				if "`15'" == "`inter`x''" {
					local 16 = `16'*`shock_val'
				}
				if "`17'" == "`inter`x''" {
					local 18 = `18'*`shock_val'
				}
				if "`19'" == "`inter`x''" {
					local 20 = `20'*`shock_val'
				}
				if "`21'" == "`inter`x''" {
					local 22 = `22'*`shock_val'
				}
				if "`23'" == "`inter`x''" {
					local 24 = `24'*`shock_val'
				}
				if "`25'" == "`inter`x''" {
					local 26 = `26'*`shock_val'
				}
				if "`27'" == "`inter`x''" {
					local 28 = `28'*`shock_val'
				}
				if "`29'" == "`inter`x''" {
					local 30 = `30'*`shock_val'
				}
				if "`31'" == "`inter`x''" {
					local 32 = `32'*`shock_val'
				}
				if "`33'" == "`inter`x''" {
					local 34 = `34'*`shock_val'
				}
				if "`35'" == "`inter`x''" {
					local 36 = `36'*`shock_val'
				}
				if "`37'" == "`inter`x''" {
					local 38 = `38'*`shock_val'
				}
				if "`39'" == "`inter`x''" {
					local 40 = `40'*`shock_val'
				}
				if "`41'" == "`inter`x''" {
					local 42 = `42'*`shock_val'
				}
			local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			return local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			* return list
			}
		}
		if "`inter4'" == "" & "`inter3'" ~= "" {
			forvalues x = 1(1)3 {
				if `num' == 1 {
					tokenize `scen1'
				}
				if `num' == 2 {
					tokenize `scen2'
				}
				if `num' == 3 {
					tokenize `scen3'
				}
				if `num' == 4 {
					tokenize `scen4'
				}
				if "`1'" == "`inter`x''" {
					local 2 = `2'*`shock_val'
				}
				if "`3'" == "`inter`x''" {
					local 4 = `4'*`shock_val'
				}
				if "`5'" == "`inter`x''" {
					local 6 = `6'*`shock_val'
				}
				if "`7'" == "`inter`x''" {
					local 8 = `8'*`shock_val'
				}
				if "`9'" == "`inter`x''" {
					local 10 = `10'*`shock_val'
				}
				if "`11'" == "`inter`x''" {
					local 12 = `12'*`shock_val'
				}
				if "`13'" == "`inter`x''" {
					local 14 = `14'*`shock_val'
				}
				if "`15'" == "`inter`x''" {
					local 16 = `16'*`shock_val'
				}
				if "`17'" == "`inter`x''" {
					local 18 = `18'*`shock_val'
				}
				if "`19'" == "`inter`x''" {
					local 20 = `20'*`shock_val'
				}
				if "`21'" == "`inter`x''" {
					local 22 = `22'*`shock_val'
				}
				if "`23'" == "`inter`x''" {
					local 24 = `24'*`shock_val'
				}
				if "`25'" == "`inter`x''" {
					local 26 = `26'*`shock_val'
				}
				if "`27'" == "`inter`x''" {
					local 28 = `28'*`shock_val'
				}
				if "`29'" == "`inter`x''" {
					local 30 = `30'*`shock_val'
				}
				if "`31'" == "`inter`x''" {
					local 32 = `32'*`shock_val'
				}
				if "`33'" == "`inter`x''" {
					local 34 = `34'*`shock_val'
				}
				if "`35'" == "`inter`x''" {
					local 36 = `36'*`shock_val'
				}
				if "`37'" == "`inter`x''" {
					local 38 = `38'*`shock_val'
				}
				if "`39'" == "`inter`x''" {
					local 40 = `40'*`shock_val'
				}
				if "`41'" == "`inter`x''" {
					local 42 = `42'*`shock_val'
				}
			local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			return local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			* return list
			}
		}
		if "`inter4'" == "" & "`inter3'" == "" & "`inter2'" ~= "" {
			forvalues x = 1(1)2 {
				if `num' == 1 {
					tokenize `scen1'
				}
				if `num' == 2 {
					tokenize `scen2'
				}
				if `num' == 3 {
					tokenize `scen3'
				}
				if `num' == 4 {
					tokenize `scen4'
				}
				if "`1'" == "`inter`x''" {
					local 2 = `2'*`shock_val'
				}
				if "`3'" == "`inter`x''" {
					local 4 = `4'*`shock_val'
				}
				if "`5'" == "`inter`x''" {
					local 6 = `6'*`shock_val'
				}
				if "`7'" == "`inter`x''" {
					local 8 = `8'*`shock_val'
				}
				if "`9'" == "`inter`x''" {
					local 10 = `10'*`shock_val'
				}
				if "`11'" == "`inter`x''" {
					local 12 = `12'*`shock_val'
				}
				if "`13'" == "`inter`x''" {
					local 14 = `14'*`shock_val'
				}
				if "`15'" == "`inter`x''" {
					local 16 = `16'*`shock_val'
				}
				if "`17'" == "`inter`x''" {
					local 18 = `18'*`shock_val'
				}
				if "`19'" == "`inter`x''" {
					local 20 = `20'*`shock_val'
				}
				if "`21'" == "`inter`x''" {
					local 22 = `22'*`shock_val'
				}
				if "`23'" == "`inter`x''" {
					local 24 = `24'*`shock_val'
				}
				if "`25'" == "`inter`x''" {
					local 26 = `26'*`shock_val'
				}
				if "`27'" == "`inter`x''" {
					local 28 = `28'*`shock_val'
				}
				if "`29'" == "`inter`x''" {
					local 30 = `30'*`shock_val'
				}
				if "`31'" == "`inter`x''" {
					local 32 = `32'*`shock_val'
				}
				if "`33'" == "`inter`x''" {
					local 34 = `34'*`shock_val'
				}
				if "`35'" == "`inter`x''" {
					local 36 = `36'*`shock_val'
				}
				if "`37'" == "`inter`x''" {
					local 38 = `38'*`shock_val'
				}
				if "`39'" == "`inter`x''" {
					local 40 = `40'*`shock_val'
				}
				if "`41'" == "`inter`x''" {
					local 42 = `42'*`shock_val'
				}
			local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			return local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			* return list
			}
		}
		if "`inter4'" == "" & "`inter3'" == "" & "`inter2'" == "" {
			local x = 1 
				if `num' == 1 {
					tokenize `scen1'
				}
				if `num' == 2 {
					tokenize `scen2'
				}
				if `num' == 3 {
					tokenize `scen3'
				}
				if `num' == 4 {
					tokenize `scen4'
				}
				if "`1'" == "`inter`x''" {
					local 2 = `2'*`shock_val'
				}
				if "`3'" == "`inter`x''" {
					local 4 = `4'*`shock_val'
				}
				if "`5'" == "`inter`x''" {
					local 6 = `6'*`shock_val'
				}
				if "`7'" == "`inter`x''" {
					local 8 = `8'*`shock_val'
				}
				if "`9'" == "`inter`x''" {
					local 10 = `10'*`shock_val'
				}
				if "`11'" == "`inter`x''" {
					local 12 = `12'*`shock_val'
				}
				if "`13'" == "`inter`x''" {
					local 14 = `14'*`shock_val'
				}
				if "`15'" == "`inter`x''" {
					local 16 = `16'*`shock_val'
				}
				if "`17'" == "`inter`x''" {
					local 18 = `18'*`shock_val'
				}
				if "`19'" == "`inter`x''" {
					local 20 = `20'*`shock_val'
				}
				if "`21'" == "`inter`x''" {
					local 22 = `22'*`shock_val'
				}
				if "`23'" == "`inter`x''" {
					local 24 = `24'*`shock_val'
				}
				if "`25'" == "`inter`x''" {
					local 26 = `26'*`shock_val'
				}
				if "`27'" == "`inter`x''" {
					local 28 = `28'*`shock_val'
				}
				if "`29'" == "`inter`x''" {
					local 30 = `30'*`shock_val'
				}
				if "`31'" == "`inter`x''" {
					local 32 = `32'*`shock_val'
				}
				if "`33'" == "`inter`x''" {
					local 34 = `34'*`shock_val'
				}
				if "`35'" == "`inter`x''" {
					local 36 = `36'*`shock_val'
				}
				if "`37'" == "`inter`x''" {
					local 38 = `38'*`shock_val'
				}
				if "`39'" == "`inter`x''" {
					local 40 = `40'*`shock_val'
				}
				if "`41'" == "`inter`x''" {
					local 42 = `42'*`shock_val'
				}
			local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			return local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			* return list
		}
end
*/

* this is the ch_inter_value code from the updated dynsim command
capture program drop ch_inter_value
program define ch_inter_value, rclass
syntax, inter(string) shock_val(real) num(real) [ scen1(string) scen2(string) scen3(string) scen4(string)]
		tokenize "`inter'"
		local inter1 `1'
		local inter2 `2'
		local inter3 `3'
		local inter4 `4'
		if "`inter4'" ~= "" {
			local stop = 4
		}
		if "`inter4'" == "" & "`inter3'" ~= "" {
			local stop = 3
		}
		if "`inter4'" == "" & "`inter3'" == "" & "`inter2'" ~= "" {
			local stop = 2
		}
		if "`inter4'" == "" & "`inter3'" == "" & "`inter2'" == "" {
			local stop = 1
		}
			forvalues x = 1(1)`stop' {
				if `num' == 1 {
					tokenize `scen1'
				}
				if `num' == 2 {
					tokenize `scen2'
				}
				if `num' == 3 {
					tokenize `scen3'
				}
				if `num' == 4 {
					tokenize `scen4'
				}
					forvalues i = 1(2)41 {
					 	if "``i''" == "`inter`x''" {
					 		local next = `i' + 1
							local value = ``next''*`shock_val'
							local `next' = `value'
 						}
 					}
				local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
				return local scen`num' `1' `2' `3' `4' `5' `6' `7' `8' `9' `10' `11' `12' `13' `14' `15' `16' `17' `18' `19' `20' `21' `22' `23' `24' /*
*/				`25' `26' `27' `28' `29' `30' `31' `32' `33' `34' `35' `36' `37' `38' `39' `40' `41' `42'
			}
end


capture program drop cr_scen_miss
program define cr_scen_miss, rclass
syntax, scen1(string) [ scen2(string) scen3(string) scen4(string) ]
tokenize "`scen1'"
local scen_miss_1 `1'
	* di "`scen_miss_1'"
tokenize "`scen2'"
local scen_miss_2 `1'
	* di "`scen_miss_2'"
tokenize "`scen3'"
local scen_miss_3 `1'
	* di "`scen_miss_3'"
tokenize "`scen4'"
local scen_miss_4 `1'
	* di "`scen_miss_4'"
	if "`scen_miss_2'" == "" & "`scen_miss_3'" == "" & "`scen_miss_4'" == "" {
		local num = 1
		* di `num'
	}
	if "`scen_miss_4'" == "" & "`scen_miss_3'" == "" & "`scen_miss_2'" ~= "" {
		local num = 2
		* di `num'
	}
	if "`scen_miss_4'" == "" & "`scen_miss_3'" ~= "" {
		local num = 3
		* di `num'
	}
	if "`scen4'" ~= "" {
		local num = 4
		* di `num'	
	}
	return local num `num'
end



